import java.awt.*;
import java.awt.event.*;  
import java.awt.image.*;  
import java.util.*;
import javax.swing.*;
import javax.imageio.*;
import java.io.*;
import java.nio.ByteBuffer;

//**************************************************
public class ImageMemoryStream_Demo extends JFrame
{
	Image img = null;

   JTextField txt = null;
	
	ImageCanvas can = null;
   
	JPanel pan = null;
   
   boolean letterWriting = false;
	
   //------------------------------
	public static void main(String args[])
	{
	   SwingUtilities.invokeLater
		(
		   new Runnable()
			{
				@Override
				public void run()
				{
					new ImageMemoryStream_Demo();
				}
			}
		   
		);
	}
 
	//------------------------------
	public ImageMemoryStream_Demo()
	{
   
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setTitle("ImageMemoryStream_Demo");
		setSize(512, 300);
		setLocation(50,50);
		
		//........................
		setLayout(new BorderLayout());
		ButtonHandler btnHandler = new ButtonHandler(this);
		
		pan = new JPanel();
		
		add(pan , BorderLayout.SOUTH);
		
		String[] filters = {"Image", "Normal", "Save", "", "б", "", "б"};
		
		for(int i=0; i<filters.length; i++) {
			JButton b = new JButton(filters[i]);
			b.addActionListener(btnHandler);
			pan.add(b);
		}
	   
      txt = new JTextField(15);
		txt.setBackground(new Color(255,200,0));
      
      txt.addActionListener
		(
		   new ActionListener()
			{
				@Override
				public void actionPerformed(ActionEvent e)
				{
               if(letterWriting == false) return;
				   can.writeLetter(txt.getText());
               txt.setText("");
				}
			}
		);
      
		add(txt, BorderLayout.NORTH);
		
		can = new ImageCanvas(this);
      
		add(can, BorderLayout.CENTER);
		//........................
		
		setVisible(true);
	}

	//------------------------------
	Image loadImage()
	{
	   FileDialog fd = new FileDialog(this,"Open", FileDialog.LOAD);
		fd.setVisible(true);

		if(fd.getFile() == null) return null;

		Image img = null;
		
      try {
			MediaTracker traker = new MediaTracker(this);
				
			img = Toolkit.getDefaultToolkit().getImage(fd.getDirectory() + fd.getFile());
				
			traker.addImage(img, 0);
				
			traker.waitForID(0);
				
			traker.removeImage(img, 0);
		}
		catch(InterruptedException e) {
			System.out.println("Interrupted while image Tracking..");
			return null;
		}
		
		return img;
	}
	
	//----------------------------------
	void setWindowSize(Image img)
	{
		Dimension imgDim = new Dimension(img.getWidth(null), img.getHeight(null));
		Dimension panDim = pan.getPreferredSize();
		Dimension labDim = txt.getPreferredSize();
		
	   int height = imgDim.height + panDim.height + labDim.height;
		
		int width = (panDim.width > labDim.width) ? panDim.width : labDim.width ;
		width = (width > imgDim.width) ? width : imgDim.width;
		
		Insets iset = getInsets();  //Insets Ʈ , , , Ʒ 鰪  .
		
		setSize( width + (iset.left+iset.right), height + (iset.top+iset.bottom) );
	
	}
}//class ImageMemoryStream_Demo

//=======================================================================
class ButtonHandler implements ActionListener
{
   ImageMemoryStream_Demo frm = null;
	
	ButtonHandler(ImageMemoryStream_Demo f)
	{
		frm = f;
	}
	
	@Override
	public void actionPerformed(ActionEvent ae)
	{
		try {

			switch(ae.getActionCommand()) {
            case "Image":
                  Image newImg = null;
                  newImg = frm.loadImage();
                  if(newImg == null) return;
                  
                  frm.img = newImg;
                  frm.setWindowSize(frm.img);
                  
                  frm.can.set(frm.img);
                  frm.txt.setText("new image loaded.");
                  frm.repaint();
                  break;
            
            case "Normal": 
                  frm.can.set(frm.img);
                  frm.txt.setText("image initially loaded.");
                  break;
            
            case "Save": 
                  if(frm.img == null) return;
                  frm.can.imageSave();
                  frm.txt.setText("Image saved");
                  break;
                  
            case "": 
                  frm.letterWriting = true;
                  frm.txt.setText("");
                  JButton b = (JButton)ae.getSource();
                  b.setText("");
                  frm.txt.grabFocus();
                  break;
                  
            case "׸": 
                  frm.letterWriting = false;
                  frm.txt.setText("");
                  frm.can.closLetter();
                  JButton b2 = (JButton)ae.getSource();
                  b2.setText("׸");
                  break;
                  
             case "б":  
                  frm.can.readLetter();
                  frm.txt.setText("б");
                  break;
                  
            case "":
                  if(frm.img == null) return;
                  frm.can.docSave();
                  frm.txt.setText("file absorbed.");
                  break;
            
            case "б":
                  if(frm.img == null) return;
                  frm.can.docExtract();
                  frm.txt.setText("file extracted.");
                  break;
         }//switch
         
		}
      catch(Exception e) {
         frm.txt.setText("Exception Occurs: " + ae.getActionCommand());
      }
		
	}//actionPerformed
}//BtnHandler


//=======================================================================
class ImageCanvas extends JPanel
{

   ImageMemoryStream_Demo frm;
   
	Image img = null;
   int width, height;
   
   ImageMemoryOutputStream imageLetter = null;
   
	//-----------------------------------------
	ImageCanvas(ImageMemoryStream_Demo frm)
	{
	   this.frm = frm;
	}
	
   //-----------------------------------------
	void set(Image img)
	{
   
	   if(img != null) {
			try {
				MediaTracker mt = new MediaTracker(this);
			
				mt.addImage(img, 0);
				mt.waitForAll();
			}
			catch(InterruptedException ex) {
				System.out.println("Interrupted.");
				return;
			}//
		}
	
		this.img = img;
      
      width = img.getWidth(null);
      height = img.getHeight(null);
      
		repaint();
	}
   
   //-----------------------------------------
   @Override
	public void paintComponent(Graphics g)
	{
		if(img == null) {
		   g.drawString("No image to display.", 20, 50);
		}
		else {
	      setBackground(Color.WHITE);
			g.drawImage(img, 0, 0, this);
		}
	}
	
   //-----------------------------------------
	@Override 
	public Dimension getPreferredSize()
	{
	   if(img == null) return new Dimension(0, 0);
		return new Dimension(img.getWidth(this), img.getHeight(this));
	}
	
   //-----------------------------------------
	@Override
	public Dimension getMinimumSize()
	{
		return getPreferredSize();
	}
   
   //---------------------------------------------------------
   boolean imageSave()
   {
      
      BufferedImage bimg;
      
      if (img instanceof BufferedImage)
      {
         bimg = (BufferedImage)img;
      }
      else {
         bimg = new BufferedImage(img.getWidth(null), img.getHeight(null), BufferedImage.TYPE_3BYTE_BGR);
         Graphics2D g = bimg.createGraphics();
         g.drawImage(img, 0, 0, null);
         g.dispose();
      }
      
      try {
         FileDialog fd = new FileDialog(frm, "save", FileDialog.SAVE);
		   fd.setVisible(true);
		   if(fd.getFile() == null) return false;
         
         String fileType = "png";
         String fileName = fd.getFile();
         int indx = fileName.lastIndexOf('.');
         if(indx == -1) fileName += ("." + fileType);
         else fileName = fileName.substring(0, indx+1) + fileType;
         
         System.out.println("saving: type:" + fileType + "  fileName: " + fd.getDirectory() + fileName);
         
         ImageIO.write(bimg, fileType, new File(fd.getDirectory() + fileName));
      }
      catch(IOException  ex) {
         System.out.println("IOError: \n" + ex);
         return false;
      }
      
      return true;
   }
   
   //-----------------------------------------
   void writeLetter(String str)
   {
      if(img == null) return;
      if(frm.letterWriting == false) return;
      
      try {
         if(imageLetter == null) {
            imageLetter = new ImageMemoryOutputStream(img);
         }
         imageLetter.writeString(str);
         System.out.println(str);
      }
      catch(IOException ex) {
         System.out.println("IOError: " + ex);
      }
      catch(Exception ex) {
         System.out.println("Error: " + ex);
      }
     
   }
   
   //----------------------------------------
   void closLetter()
   {
      try {
         if(imageLetter != null) {
            int[] pixels = imageLetter.getPixelArray();
            img = frm.createImage(new MemoryImageSource(width, height, pixels, 0, width));
            imageLetter.close();
            imageLetter = null;
         }
      }
      catch(IOException ex) {
         System.out.println("IOError: " + ex);
      }
      catch(Exception ex) {
         System.out.println("Error: " + ex);
      }
   }
   
   //----------------------------------------
   void readLetter()
   {
      if(imageLetter != null) {
         System.out.println("***   Դϴ.");
         return;
      }
      
      ImageMemoryInputStream letter=null;
      
      System.out.println("\n===========================================");
      try {
  
         letter = new ImageMemoryInputStream(img);
         
         for(;;) {
         
            String str = letter.readString();
            System.out.println(str);
         }
         
      }
      catch(IOException ex) {
         
      }
      catch(Exception ex) {
         System.out.println("Error: " + ex);
      }
      finally {
         try {
            if(letter != null) letter.close();
         }
         catch(IOException ex) {
         }
      }
      
   }
   
   //-----------------------------------------
   void docSave()
   {

      FileDialog fd = new FileDialog(frm,"Open", FileDialog.LOAD);
		fd.setVisible(true);

		if(fd.getFile() == null) return;
      
      String filename = fd.getDirectory() + fd.getFile();
      
      String foobar = "foobar-" + fd.getFile();
      
      FileInputStream fin = null;
      
      ImageMemoryOutputStream imos = null;
      
      int[] pixels = null;

      try {
         fin = new FileInputStream(filename);
         int filesize = fin.available();

         imos = new ImageMemoryOutputStream(img);
         
         imos.writeString(foobar);
         
         imos.writeLong((long)filesize);
         
         long count = 0;
         for(int x=fin.read(); x != -1; x=fin.read()) {
            imos.write(x);
            count++;
         }
         
         pixels = imos.getPixelArray();
         
      }//try
      catch(IOException ex) {
         System.out.println("File IOException: " + ex);
      }
      catch(Exception ex) {
         System.out.println("File read error: " + ex.getMessage());
      }
      finally {
         try {
            if(fin != null) fin.close();
            if(imos != null) imos.close();
         }
         catch(IOException ex) {
            System.out.println("File Close error(absorb): " + ex);
         }
      }
      
      img = frm.createImage(new MemoryImageSource(width, height, pixels, 0, width));
      
      repaint();
   }
   
   //-----------------------------------------
   void docExtract()
   {
      ImageMemoryInputStream imis = null;
      FileOutputStream fout = null;
      
      try {
         imis = new ImageMemoryInputStream(img);
         
         String filename = imis.readString();
         
         int idIndx = filename.indexOf('-');
         if(idIndx == -1) throw new Exception(" ϰ ִ ̹ ƴմϴ.");
         String idStr = filename.substring(0, idIndx);
         
         if(idStr.equals("foobar") == false) throw new Exception("Can't find [foobar]");
 
         System.out.println("Hello [" + idStr + "]!");
         
         fout = new FileOutputStream(filename);
         
         long fileLen = imis.readLong();

         for(int i=0; i<fileLen; i++) {
            fout.write(imis.read());
         }   

      }
      catch(IOException ex) {
         System.out.println("File IOException: " + ex);
      }
      catch(Exception ex) {
         System.out.println("File read error(extract): " + ex.getMessage());
      }
      finally {
         try {
            if(imis != null) imis.close();
            if(fout != null) fout.close();
         }
         catch(IOException ex) {
            System.out.println("File Close error: " + ex);
         }
      }
      
   }
   
}//calss DemoCanvas
